? src/lib-storage/index/mbox/diff
Index: src/lib-storage/index/mbox/mbox-sync.c
===================================================================
RCS file: /var/lib/cvs/dovecot/src/lib-storage/index/mbox/mbox-sync.c,v
retrieving revision 1.161
diff -u -r1.161 mbox-sync.c
--- src/lib-storage/index/mbox/mbox-sync.c	14 May 2005 17:17:29 -0000	1.161
+++ src/lib-storage/index/mbox/mbox-sync.c	23 May 2005 21:54:27 -0000
@@ -1162,7 +1162,22 @@
 	}
 
 	file_size = st->st_size;
-	i_assert(file_size >= sync_ctx->file_input->v_offset);
+	if (file_size < sync_ctx->file_input->v_offset) {
+		struct stat st1, st2;
+
+		if (fstat(sync_ctx->ibox->mbox_fd, &st1) < 0)
+			i_error("fstat(mbox) failed: %m");
+		if (stat(sync_ctx->ibox->path, &st2) < 0)
+			i_error("stat(mbox) failed: %m");
+
+		if (st1.st_ino != st2.st_ino)
+			i_error("MBOX %s: inodes differ", sync_ctx->ibox->path);
+		i_error("MBOX %s: sizes differ: %"PRIuUOFF_T" vs %"
+			PRIuUOFF_T" vs. %"PRIuUOFF_T, sync_ctx->ibox->path,
+			st1.st_size, st2.st_size,
+			sync_ctx->file_input->v_offset);
+		return -1;
+	}
 	trailer_size = file_size - sync_ctx->file_input->v_offset;
 	i_assert(trailer_size <= 1);
 
